package de.mdelab.mlsdm.diagram.custom.edit.parts;


import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StoryNodeSemanticsEnum;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart;

public class CustomStoryNode2EditPart extends StoryNode2EditPart
{

	public CustomStoryNode2EditPart(View view)
	{
		super(view);
	}

	@Override
	protected void handleNotificationEvent(Notification notification)
	{
		if (notification.getNotifier() instanceof StoryNode)
		{
			updateFigure();
			//repaint();
			
			
		}

		super.handleNotificationEvent(notification);
	}

	protected void updateFigure()
	{
		StoryNodeSemanticsEnum isForEach = ((StoryNode) ((View) getModel()).getElement()).getSemantics();
		RectangleFigure frontRectangle = (RectangleFigure) getPrimaryShape().getChildren().get(1);

		Insets frontInsets = frontRectangle.getBorder().getInsets(frontRectangle);
	
		if (isForEach == StoryNodeSemanticsEnum.SINGLE_MATCH)
		{
			frontInsets.top = 0;
			frontInsets.bottom = 0;
			frontInsets.left = 0;
			frontInsets.right = 0;
		}
		else
		{
			frontInsets.top = 0;
			frontInsets.bottom = 10;
			frontInsets.left = 0;
			frontInsets.right = 10;
		}
		
		//RectangleFigure  backRectangle = (RectangleFigure) getPrimaryShape().getChildren().get(0);
		//backRectangle.setAlpha(70);
		//((StoryPatternEditPart)((EditPart)getPrimaryShape().getChildren().get(0)).getChildren().get(0)).getPrimaryShape().setMinimumSize(getPrimaryShape().getSize());

		//this.repaint();
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		updateFigure();

	}
//	private void repaint()
//	{
		//final StoryNode sN = (StoryNode) ((View) getModel()).getElement();
		//EditPart compartment = (EditPart)this;
		//final View diag = (View)compartment.getModel();
		//TransactionalEditingDomain ted = TransactionUtil.getEditingDomain(diag);
		//JOptionPane.showInputDialog(((StoryNode) ((View) getModel()).getElement()).getStoryPattern());
		//if (sN.getStoryPattern()==null){
		//	JOptionPane.showInputDialog(((StoryNode) ((View) getModel()).getElement()).getStoryPattern());
			//final StoryPattern sp = MlstorypatternsFactory.eINSTANCE.createStoryPattern();

//				AbstractEMFOperation operation = new AbstractEMFOperation(ted, "addStoryPattern", null)
//				{
//					protected IStatus doExecute(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
//					{
//						ViewUtil.setStructuralFeatureValue(diag,MlsdmPackage.eINSTANCE.getStoryNode_StoryPattern(), sp);
//						return Status.OK_STATUS;
//					}
//				};
		//}
		// Get the StoryPattern Compartment.
	/*	IFigure rectangleFront = (IFigure) ((IFigure) getFigure().getChildren().get(0)).getChildren().get(1);
		//JOptionPane.showInputDialog(rectangleFront);
		rectangleFront =  (IFigure) rectangleFront.getChildren().get(0);
		//JOptionPane.showInputDialog(rectangleFront);
		IFigure rectangleContent = (IFigure) rectangleFront.getChildren().get(1);
		IFigure rectangleFront2 = (IFigure) rectangleContent.getChildren().get(0);
		//JOptionPane.showInputDialog(rectangleFront2);
		IFigure rectangleContent2 = (IFigure) rectangleFront2.getChildren().get(0);
		rectangleContent2 = (IFigure) rectangleContent2.getChildren().get(1);*/
//	}
//	protected void execute(AbstractTransactionalCommand command)
//	{
//		try
//		{
//			OperationHistoryFactory.getOperationHistory().execute(command, new NullProgressMonitor(), null);
//		}
//		catch (ExecutionException ee)
//		{
//			ee.printStackTrace();
//		}
//	}
}
